Status: Resolved Priority: Must have
Author: Rens Admiraal Category: Reflection
Created: 2012-07-31 Assigned To: Robert Lemke
Updated: 2014-07-11 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: Git master
Subject: AOP: Property introduction seems to be broken
Description

Introducing a property does not work at the moment. The functional tests are passing.

Attached is a Test package as example to show the problem.

Related issues:
related to TYPO3.Flow - Bug # 27045: Introduced properties are not available ... New 2011-05-26
related to TYPO3.Flow - Feature # 37373: Make annotation overrides / "injecti... Under Review 2012-05-21

Associated revisions
Revision 915b71ce - 2013-06-10 12:39 - Alexander Berl

[BUGFIX] Property introduction is broken

This change fixes property introduction through aspects by adding
missing checks for available property introductions.

Change-Id: I0e89a6f9eca218c2e29956c7416dcede4b7d2b1a
Fixes: #39413
Releases: master, 2.0

Revision 23492025 - 2013-06-14 12:46 - Alexander Berl

[BUGFIX] Property introduction is broken

This change fixes property introduction through aspects by adding
missing checks for available property introductions.

Change-Id: I0e89a6f9eca218c2e29956c7416dcede4b7d2b1a
Fixes: #39413
Releases: master, 2.0

History
#1 - 2012-07-31 15:56 - Rens Admiraal

Extra info: property introduction does work if you also introduce an interface in the aspect. But as there could be usecases where you don't want to
introduce methods it should be possible to do without that.
#2 - 2012-07-31 18:47 - Rens Admiraal

debugged a bit further, seems like getProperties() in the reflectionService does not have the introduced properties during the compile run, so
doctrine:migrationgenerate does not pick up the new properties. Might be a good thing if someone more into the reflection / proxy building stuff has a
look at this issue.

#3 - 2012-08-07 15:25 - Karsten Dambekalns
- Project changed from TYPO3 Flow Base Distribution to TYPO3.Flow

#4 - 2012-08-07 15:25 - Karsten Dambekalns
- Category set to Reflection
- Has patch set to No

#5 - 2012-10-31 17:45 - Robert Lemke
- Assigned To set to Robert Lemke

#6 - 2012-12-13 12:35 - Karsten Dambekalns
- Affected Flow version changed from Git 1.2 (master) to Git master

#7 - 2013-03-07 15:15 - Christoph Gross

Bug still present in current master. Introduced properties are not added by doctrine.

Uncaught Exception
    The class "CGROSS\Drinkaccounting\Aop\MultiCommunitySupport" is tagged
  to
    be an aspect but doesn't contain advices nor pointcut or introduction
    declarations.

<?php
namespace CGROSS\Drinkaccounting\Aop;

use TYPO3\Flow\Annotations as Flow;

/**
 * Inject community-attribute to every class
 *
 * @Flow\Aspect
 */
class MultiCommunitySupport {

    /**
     * @var string
     * @Flow\Introduce("class(CGROSS\Drinkaccounting\Domain\Model\User)")
     */
    protected $community;

}
Adding a pointcut (even if not used) and the error message is gone BUT the property is still not created by doctrine:update.

<?php
namespace CGROSS\Drinkaccounting\Aop;

use TYPO3\Flow\Annotations as Flow;

/**
 * Inject community-attribute to every class
 *
 * @Flow\Aspect
 */
class MultiCommunitySupport {

    /**
     * A pointcut which matches all guestbook submission method invocations
     *
     * @Flow\Pointcut("method(CGROSS\Drinkaccounting\Domain\Model\User->create())")
     */
    public function guestbookSubmissionPointcut() {}

    /**
     * @var string
     * @Flow\Introduce("class(CGROSS\Drinkaccounting\Domain\Model\User)")
     */
    protected $community;

}

#8 - 2013-04-15 23:49 - Alexander Berl

There are actually two points where propertyIntroduction is not taken into consideration:

1. At the end of ProxyClassBuilder->buildAspectContainer, the count of propertyIntroductions isn't taken into account before throwing the "doesn't
contain advices nor pointcut or introductions" exception.

2. In AspectContainer->reduceTargetClassNames, the targetClassName cache isn't reduced over propertyIntroductions, leading to all classes that are
not also subject to another advice or interface introduction to not be considered at all, hence no property is introduced in the proxy class.

I'll provide a change set for that tomorrow. From there on it's maybe easier to find the spot where to put a proper update of the reflectionData.
My current assumption is, that the ReflectionData is collected before the proxy exists and afterwards the reflectionData isn't updated anymore.

#9 - 2013-04-16 12:21 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20000
#10 - 2013-05-28 12:22 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20000

#11 - 2013-05-28 12:25 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20000

#12 - 2013-06-10 12:40 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20000

#13 - 2013-06-14 12:47 - Gerrit Code Review

Patch set 1 for branch 2.0 has been pushed to the review server.
It is available at https://review.typo3.org/21418

#14 - 2014-07-11 20:19 - Alexander Berl
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:915b71ce7346b7c6cc33e95ccb9d628f7023bbb1.
